/*

  yyycpu - a virtual machine
  Copyright (C) 2000  Erik Thiele

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  
  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/

#include "symbollist.hpp"

#include <stdio.h>

symbollist::symbollist()
{
};

symbollist::~symbollist()
{
};

/*symbollist::index_t symbollist::add (const string &symbol)
{
  for (index_t i=0;i<vec.size();i++)
    if (vec[i].symbol==symbol) throw "symbollist::add: symbol \"" + symbol + "\" already defined";
  vec.push_back(elem(symbol));
  return vec.size()-1;
};*/

/*symbollist::index_t symbollist::find (const string &symbol)
{
  for (index_t i=0;i<vec.size();i++)
    if (vec[i].symbol==symbol) return i;
  throw "symbollist::find: symbol \"" + symbol + "\" unknown";
};*/

symbollist::index_t symbollist::findoradd (const string &symbol)
{
  for (index_t i=0;i<vec.size();i++)
    if (vec[i].symbol==symbol) return i;
  vec.push_back(elem(symbol));
  return vec.size()-1;
};

void symbollist::debugprint ()
{
  printf("SYMBOLLIST DEBUG\n");
  for (index_t i=0;i<vec.size();i++) {
    printf("INDEX=%d SYMBOL=%s\n", i, vec[i].symbol.c_str());
  };
};
